﻿using System;
using Styx.Plugins;
using UI;

namespace PotionUser
{
// ReSharper disable UnusedMember.Global
    public class PotionUser : HBPlugin
// ReSharper restore UnusedMember.Global
    {
        #region Overrides of HBPlugin

        private bool _init;

        /// <summary>
        /// The text of the button if the plugin wants it. [Default: "Settings"]
        /// </summary>
        public override string ButtonText
        {
            get { return "Click me!"; }
        }

        /// <summary>
        /// Does this plugin want a button? If set to true, the button in the plugin manager will be enabled. [Default: false]
        /// </summary>
        public override bool WantButton
        {
            get { return true; }
        }

        /// <summary>
        /// The name of this plugin.
        /// </summary>
        public override string Name
        {
            get { return "Potion User"; }
        }

        /// <summary>
        /// The author of this plugin.
        /// </summary>
        public override string Author
        {
            get { return "Weischbier"; }
        }

        /// <summary>
        /// The version of the plugin.
        /// </summary>
        public override Version Version
        {
            get { return new Version(1, 0, 1); }
        }

        /// <summary>
        /// Called when the user presses the button while having this plugin selected. The plugin can start a thread, show a form, or just do what the hell it wants.
        /// </summary>
        public override void OnButtonPress()
        {
            new UserInterface.UserInterface().ShowDialog();
        }

        /// <summary>
        /// Initializes this plugin after it has been properly loaded.
        /// </summary>
        public override void Initialize()
        {
            //Prevents double initialization
            if (_init) return;
            base.Initialize();
            PuLogger.InfoLog(string.Format("Potion User ready to use . . ."));
            BeSettings.Instance.Load();
            _init = true;
        }

        /// <summary>
        /// Called everytime the engine pulses.
        /// </summary>
        public override void Pulse()
        {
            if (_init)
                Item.Dthdjhdrsrdzjh();
        }

        #endregion
    }
}