﻿using Styx;
using Styx.Helpers;

namespace UI
{
    public class BeSettings : Settings
    {
        private static BeSettings _instance;

        private BeSettings() : base(SettingsPath + ".config")
        {
        }
        private static string SettingsPath
        {
            get
            {
                return string.Format("{0}\\Settings\\Potion User\\PotionUser_{1}_{2}",
                                     PuLogger.ApplicationPath, StyxWoW.Me.Class, StyxWoW.Me.Name);
            }
        }

        public static BeSettings Instance
        {
            get { return _instance ?? (_instance = new BeSettings()); }
        }

        [Setting]
        [DefaultValue(PuEnumeration.TrinketUsage.OnBoss)]
        public PuEnumeration.TrinketUsage Trinket1Usage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.TrinketUsage.OnBoss)]
        public PuEnumeration.TrinketUsage Trinket2Usage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.SynapseSpringsUsage.OnCooldownInCombat)]
        public PuEnumeration.SynapseSpringsUsage SsUsage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.PlasmaShieldUsage.Emergency)]
        public PuEnumeration.PlasmaShieldUsage PlasmaUsage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.PotionUsage.GolemBloodPotion)]
        public PuEnumeration.PotionUsage PotionUsage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.ElixierUsage.None)]
        public PuEnumeration.ElixierUsage ElixierUsage { get; set; }

        [Setting]
        [DefaultValue(PuEnumeration.FlaskUsage.None)]
        public PuEnumeration.FlaskUsage FlaskUsage { get; set; }

        [Setting]
        [DefaultValue(false)]
        public bool Spirit { get; set; }

        #region Categroy: ints

        [Setting]
        [DefaultValue(35)]
        public int LowHealthvalue { get; set; }

        [Setting]
        [DefaultValue(3)]
        public int AddcountValue { get; set; }

        [Setting]
        [DefaultValue(35)]
        public int HealPotValue { get; set; }

        [Setting]
        [DefaultValue(35)]
        public int ManaPotValue { get; set; }

        #endregion
    }
}