using System.Collections.Generic;

namespace UI
{
    public static class List
    {
        #region Boss Entries

        private static readonly HashSet<uint> Dummies = new HashSet<uint>
                                                            {
                                                                31146,
                                                                // Raider's
                                                                46647,
                                                                // 81-85
                                                                32546,
                                                                // Ebon Knight's (DK)
                                                                31144,
                                                                // 79-80
                                                                32543,
                                                                // Veteran's (Eastern Plaguelands)
                                                                32667,
                                                                // 70
                                                                32542,
                                                                // 65 EPL
                                                                32666,
                                                                // 60
                                                                30527,
                                                                // ?? Boss one (no idea?)
                                                            };

        private static readonly HashSet<uint> Bosses = new HashSet<uint>
                                                           {
                                                               //Icecrown Citadel
                                                               36612,
                                                               //Lord Marrowgar
                                                               36855,
                                                               //Lady Deathwhisper

                                                               //Gunship Battle
                                                               37813,
                                                               //Deathbringer Saurfang
                                                               36626,
                                                               //Festergut
                                                               36627,
                                                               //Rotface
                                                               36678,
                                                               //Professor Putricide
                                                               37972,
                                                               //Prince Keleseth (Icecrown Citadel)
                                                               37970,
                                                               //Prince Valanar
                                                               37973,
                                                               //Prince Taldaram (Icecrown Citadel)
                                                               37955,
                                                               //Queen Lana'thel
                                                               36789,
                                                               //Valithria Dreamwalker
                                                               37950,
                                                               //Valithria Dreamwalker (Phased)
                                                               37868,
                                                               //Risen Archmage, Valitrhia Add
                                                               36791,
                                                               //Blazing Skeleton, Valithria Add
                                                               37934,
                                                               //Blistering Zombie, Valithria Add
                                                               37886,
                                                               //Gluttonous Abomination, Valithria Add
                                                               37985,
                                                               //Dream Cloud , Valithria "Add" 
                                                               36853,
                                                               //Sindragosa
                                                               36597,
                                                               //The Lich King (Icecrown Citadel)
                                                               37217,
                                                               //Precious
                                                               37025,
                                                               //Stinki
                                                               36661,
                                                               //Rimefang <Drake of Tyrannus>

                                                               //Blackrock Mountain: Blackrock Caverns
                                                               39665,
                                                               //Rom'ogg Bonecrusher
                                                               39679,
                                                               //Corla, Herald of Twilight
                                                               39698,
                                                               //Karsh Steelbender
                                                               39700,
                                                               //Beauty
                                                               39705,
                                                               //Ascendant Lord Obsidius

                                                               //Abyssal Maw: Throne of the Tides
                                                               40586,
                                                               //Lady Naz'jar
                                                               40765,
                                                               //Commander Ulthok
                                                               40825,
                                                               //Erunak Stonespeaker
                                                               40788,
                                                               //Mindbender Ghur'sha
                                                               42172,
                                                               //Ozumat

                                                               //The Stonecore
                                                               43438,
                                                               //Corborus
                                                               43214,
                                                               //Slabhide
                                                               42188,
                                                               //Ozruk
                                                               42333,
                                                               //High Priestess Azil

                                                               //The Vortex Pinnacle
                                                               43878,
                                                               //Grand Vizier Ertan
                                                               43873,
                                                               //Altairus
                                                               43875,
                                                               //Asaad

                                                               //Grim Batol
                                                               39625,
                                                               //General Umbriss
                                                               40177,
                                                               //Forgemaster Throngus
                                                               40319,
                                                               //Drahga Shadowburner
                                                               40484,
                                                               //Erudax

                                                               //Halls of Origination
                                                               39425,
                                                               //Temple Guardian Anhuur
                                                               39428,
                                                               //Earthrager Ptah
                                                               39788,
                                                               //Anraphet
                                                               39587,
                                                               //Isiset
                                                               39731,
                                                               //Ammunae
                                                               39732,
                                                               //Setesh
                                                               39378,
                                                               //Rajh

                                                               //Lost City of the Tolvir
                                                               44577,
                                                               //General Husam
                                                               43612,
                                                               //High Prophet Barim
                                                               43614,
                                                               //Lockmaw
                                                               49045,
                                                               //Augh
                                                               44819,
                                                               //Siamat

                                                               //Baradin Hold
                                                               47120,
                                                               //Argaloth
                                                               52363,
                                                               // Occu'thar

                                                               //Blackrock Mountain: Blackwing Descent
                                                               41570,
                                                               //Magmaw
                                                               42180,
                                                               //Toxitron
                                                               41378,
                                                               //Maloriak
                                                               41442,
                                                               //Atramedes
                                                               43296,
                                                               //Chimaeron
                                                               41376,
                                                               //Nefarian

                                                               //Throne of the Four Winds
                                                               45871,
                                                               //Nezir
                                                               46753,
                                                               //Al'Akir

                                                               //The Bastion of Twilight
                                                               45992,
                                                               //Valiona
                                                               45993,
                                                               //Theralion
                                                               44600,
                                                               //Halfus Wyrmbreaker
                                                               43735,
                                                               //Elementium Monstrosity
                                                               43324,
                                                               //Cho'gall
                                                               45213,
                                                               //Sinestra (heroic)

                                                               // Cata Zul'gurub
                                                               52155,
                                                               //High Priest Venoxis
                                                               52151,
                                                               //Bloodlord Mandokir
                                                               52271,
                                                               //Hazza'ra
                                                               52059,
                                                               //High Priestess Kilnara
                                                               52053,
                                                               //Zanzil
                                                               52148,
                                                               //Jin'do the Godbreaker

                                                               //Firelands
                                                               53691,
                                                               //Shannox
                                                               52558,
                                                               //Lord Rhyolith
                                                               52498,
                                                               //Beth'tilac
                                                               52530,
                                                               //Alysrazor
                                                               53494,
                                                               //Baleroc
                                                               52571,
                                                               //Majordomo Staghelm
                                                               52409,
                                                               //Ragnaros

                                                               //Dragon Soul
                                                               55265,
                                                               // Morchok
                                                               57773,
                                                               // Kohcrom (Heroic Morchok encounter)
                                                               55308,
                                                               // Zon'ozz
                                                               55312,
                                                               // Yor'sahj
                                                               55689,
                                                               // Hagara
                                                               56427,
                                                               // Blackhorn
                                                               55294,
                                                               // Ultraxion
                                                               56846,
                                                               // Arm Tentacle -- Madness of DW
                                                               56167,
                                                               // Arm Tentacle -- Madness of DW
                                                               56168,
                                                               // Wing Tentacle - Madness of DW
                                                               57962,
                                                               // Deathwing ----- Madness of DW (his head)

                                                               54431,
                                                               //Echo of Baine
                                                               54445,
                                                               54123,
                                                               54544,
                                                               54432,
                                                               54590,
                                                               54968,
                                                               54938,
                                                               55085,
                                                               54853,
                                                               55419,
                                                               54969,
                                                           };

        static List()
        {
            foreach (uint bossId in Dummies)
            {
                Bosses.Add(bossId);
            }
        }

        public static HashSet<uint> BossIds
        {
            get { return Bosses; }
        }

        #endregion
    }
}