using System.IO;
using System.Windows.Media;
using Styx.Common;

namespace UI
{
    public static class PuLogger
    {
        public static string ApplicationPath
        {
            get { return Utilities.AssemblyDirectory; }
        }

        public static void ItemLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.Pink, "[PotionUser - ItemLog] " + message, args);
        }

        public static void InfoLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.CornflowerBlue, "[PotionUser] " + message, args);
        }

        public static void DebugLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.DarkGoldenrod, "[PotionUser - DebugLog] " + message, args);
        }
    }
}