using System;
using System.Collections.Generic;
using System.Linq;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace UI
{
    public static class Unit
    {
        private static bool TargetSanityCheck
        {
            get { return StyxWoW.Me.CurrentTarget.ValidUnit(); }
        }

        private static bool ValidUnit(this WoWUnit p)
        {
            return p != null && !p.IsFriendly && p.IsValid && p.Attackable && p.IsAlive && !p.IsCritter &&
                   !p.IsNonCombatPet;
        }

        public static bool IsBoss(this WoWUnit unit)
        {
            return TargetSanityCheck && List.BossIds.Contains(unit.Entry);
        }

        public static IEnumerable<WoWUnit> UnfriendlyUnitsRadius
        {
            get
            {
                try
                {
                    var ret = ObjectManager.GetObjectsOfType<WoWUnit>(true, false)
                        .Where(unit =>
                               !unit.IsFriendly
                               && (unit.IsTargetingMeOrPet
                                   || unit.IsTargetingMyPartyMember
                                   || unit.IsTargetingMyRaidMember
                                   || unit.IsPlayer
                                   || unit.MaxHealth == 1)
                               && !unit.IsNonCombatPet
                               && !unit.IsCritter
                               && unit.Distance2D
                               <= 10);

                    return ret;
                }
                catch (NullReferenceException)
                {
                    return new List<WoWUnit>();
                }
            }
        }
    }
}