﻿using System;
using System.Windows.Forms;
using Styx;
using Styx.Common;
using UI;

namespace UserInterface
{
// ReSharper disable UnusedMember.Global
    public partial class UserInterface : Form
// ReSharper restore UnusedMember.Global
    {
        private bool _change;

        public UserInterface()
        {
            InitializeComponent();
            Text = string.Format("Potion User by Weischbier");

            pictureBox1.ImageLocation =
                string.Format("{0}\\Plugins\\Potion User\\UI\\potion.jpg",
                              PuLogger.ApplicationPath);

            //Pots
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.None, "None"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.EarthenPotion, "Earthen Potion"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.PotionofTolVir, "Potion of Tol'Vir"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.VolcanicPotion, "Volcanic Potion"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.GolemBloodPotion, "Golem Blood Potion"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.PotionofMoguPower, "Potion of the Mogu Power"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.PotionoftheJadeSerpant,"Potion of the Jade Serpant"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.PotionoftheMountains,"Potion of the Mountains"));
            _potscbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.VirmensBite, "Virmen's Bite"));

            //Flask
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.None, "None"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofBattle, "Flask of Battle"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofFallingLeaves,"Flask of Falling Leaves"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofSpringBlossoms,"Flask of Spring Blossoms"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofWintersBite,"Flask of Winter's Bite"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskoftheEarth, "Flask of the Earth"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskoftheWarmSun,"Flask of the Warm Sun"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofDraconicMind, "Flask of Draconic Mind"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofSteelskin, "Flask of Steelskin"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofFlowingWater, "Flask of Flowing Water"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskofTitanicStrength,"Flask of Titanic Strength"));
            _flaskcbo.Items.Add(new CboItem((int) PuEnumeration.FlaskUsage.FlaskoftheWinds, "Flask of the Winds"));

            //Elixier
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.PotionUsage.None, "None"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.ElixirofAncientKnowledge,"Elixir of Ancient Knowledge"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.PotionofLuck,"Potion of Luck"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.CrystalofInsanity,"Crystal of Insanity"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.AlchemistsFlask, "Alchemist's Flask"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.FlaskofEnhancement,"Flask of Enhancement"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.FlaskoftheNorth, "Flask of the North"));
            _elixiercbo.Items.Add(new CboItem((int) PuEnumeration.ElixierUsage.PotionofTreasureFinding,"Potion of Treasure Finding"));

            //Trinkets
            _trinket1cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.Never, "Never"));
            _trinket1cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.Questing, "Questing"));
            _trinket1cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.OnBoss, "On Boss"));
            _trinket1cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.OnCooldownInCombat, "On Cooldown"));
            _trinket1cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.LowHealth, "Low Health"));

            _trinket2cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.Never, "Never"));
            _trinket2cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.Questing, "Questing"));
            _trinket2cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.OnBoss, "On Boss"));
            _trinket2cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.OnCooldownInCombat, "On Cooldown"));
            _trinket2cbo.Items.Add(new CboItem((int) PuEnumeration.TrinketUsage.LowHealth, "Low Health"));

            //Synapse Springs
            _synapsecb.Items.Add(new CboItem((int) PuEnumeration.SynapseSpringsUsage.Never, "Never"));
            _synapsecb.Items.Add(new CboItem((int) PuEnumeration.SynapseSpringsUsage.OnBoss, "On Boss"));
            _synapsecb.Items.Add(new CboItem((int) PuEnumeration.SynapseSpringsUsage.OnCooldownInCombat, "On Cooldown"));
            _synapsecb.Items.Add(new CboItem((int) PuEnumeration.SynapseSpringsUsage.WithPillarofFrost,
                                             "With Pillar of Frost"));

            //Plasma Shield
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Never, "Never"));
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Under80, "80 %"));
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Under70, "70 %"));
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Under60, "60 %"));
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Under50, "50 %"));
            _plasmacb.Items.Add(new CboItem((int) PuEnumeration.PlasmaShieldUsage.Emergency, "Emergency (30 %)"));

            checkBox1.Checked = BeSettings.Instance.Spirit;
            _healpott.Value = BeSettings.Instance.HealPotValue;
            _manapott.Value = BeSettings.Instance.ManaPotValue;
            _addcountt.Value = BeSettings.Instance.AddcountValue;
            _lowhealtht.Value = BeSettings.Instance.LowHealthvalue;
            SetComboBoxEnum(_trinket1cbo, (int) BeSettings.Instance.Trinket1Usage);
            SetComboBoxEnum(_trinket2cbo, (int) BeSettings.Instance.Trinket2Usage);
            SetComboBoxEnum(_synapsecb, (int) BeSettings.Instance.SsUsage);
            SetComboBoxEnum(_plasmacb, (int) BeSettings.Instance.PlasmaUsage);
            SetComboBoxEnum(_elixiercbo, (int) BeSettings.Instance.ElixierUsage);
            SetComboBoxEnum(_flaskcbo, (int) BeSettings.Instance.FlaskUsage);
            SetComboBoxEnum(_potscbo, (int) BeSettings.Instance.PotionUsage);
        }

        public override sealed string Text
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        private void UiLoad(object sender, EventArgs e)
        {
            _change = false;

            var trinket1 = StyxWoW.Me.Inventory.GetItemBySlot(12);
            var trinket2 = StyxWoW.Me.Inventory.GetItemBySlot(13);

            if (trinket1.Usable)
            {
                Trinket1Name.Text = trinket1.Name + ":";
            }

            if (trinket2.Usable)
            {
                Trinket2Name.Text = trinket2.Name + ":";
            }
        }

        private new void Closed(object sender, FormClosingEventArgs e)
        {
            if (!_change)
                PuLogger.InfoLog("No Settings were changed.");
            else
            {
                BeSettings.Instance.Spirit = checkBox1.Checked;
                BeSettings.Instance.HealPotValue = (int) _healpott.Value;
                BeSettings.Instance.ManaPotValue = (int) _manapott.Value;
                BeSettings.Instance.AddcountValue = (int) _addcountt.Value;
                BeSettings.Instance.LowHealthvalue = (int) _lowhealtht.Value;
                BeSettings.Instance.Trinket1Usage = (PuEnumeration.TrinketUsage) GetComboBoxEnum(_trinket1cbo);
                BeSettings.Instance.Trinket2Usage = (PuEnumeration.TrinketUsage) GetComboBoxEnum(_trinket2cbo);
                BeSettings.Instance.SsUsage = (PuEnumeration.SynapseSpringsUsage) GetComboBoxEnum(_synapsecb);
                BeSettings.Instance.PlasmaUsage = (PuEnumeration.PlasmaShieldUsage) GetComboBoxEnum(_plasmacb);
                BeSettings.Instance.PotionUsage = (PuEnumeration.PotionUsage) GetComboBoxEnum(_potscbo);
                BeSettings.Instance.ElixierUsage = (PuEnumeration.ElixierUsage) GetComboBoxEnum(_elixiercbo);
                BeSettings.Instance.FlaskUsage = (PuEnumeration.FlaskUsage) GetComboBoxEnum(_flaskcbo);
                BeSettings.Instance.Save();
                PuLogger.InfoLog("Settings saved.");
            }
        }

        private static void SetComboBoxEnum(ComboBox cb, int e)
        {
            CboItem item;
            for (int i = 0; i < cb.Items.Count; i++)
            {
                item = (CboItem) cb.Items[i];
                if (item.E != e) continue;
                cb.SelectedIndex = i;
                return;
            }
            item = (CboItem) cb.Items[0];
            Logging.Write("Dialog Error: combobox {0} does not have enum({1}) in list, defaulting to enum({2})",
                          cb.Name, e, item.E);
            cb.SelectedIndex = 0;
        }


        private static int GetComboBoxEnum(ComboBox cb)
        {
            var item = (CboItem) cb.Items[cb.SelectedIndex];
            return item.E;
        }

        private void ElixiercboSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.ElixierUsage = (PuEnumeration.ElixierUsage) GetComboBoxEnum(_elixiercbo);
            PuLogger.DebugLog(string.Format("ElixierUsage Context enabled: {0}", BeSettings.Instance.ElixierUsage));
            _change = true;
        }

        private void FlaskcboSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.FlaskUsage = (PuEnumeration.FlaskUsage) GetComboBoxEnum(_flaskcbo);
            PuLogger.DebugLog(string.Format("FlaskUsage Context enabled: {0}", BeSettings.Instance.FlaskUsage));
            _change = true;
        }

        private void PotscboSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.PotionUsage = (PuEnumeration.PotionUsage) GetComboBoxEnum(_potscbo);
            PuLogger.DebugLog(string.Format("PotionUsage Context enabled: {0}", BeSettings.Instance.PotionUsage));
            _change = true;
        }

        private void Trinket1CboSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.Trinket1Usage = (PuEnumeration.TrinketUsage) GetComboBoxEnum(_trinket1cbo);
            PuLogger.DebugLog(string.Format("TrinketUsage Context enabled: {0}", BeSettings.Instance.Trinket1Usage));
            _change = true;
        }

        private void Trinket2CboSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.Trinket2Usage = (PuEnumeration.TrinketUsage) GetComboBoxEnum(_trinket2cbo);
            PuLogger.DebugLog(string.Format("Trinket2Usage Context enabled: {0}", BeSettings.Instance.Trinket2Usage));
            _change = true;
        }

        private void SynapsecbSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.SsUsage = (PuEnumeration.SynapseSpringsUsage) GetComboBoxEnum(_synapsecb);
            PuLogger.DebugLog(string.Format("SsUsage Context enabled: {0}", BeSettings.Instance.SsUsage));
            _change = true;
        }

        private void PlasmacbSelectedIndexChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.PlasmaUsage = (PuEnumeration.PlasmaShieldUsage) GetComboBoxEnum(_plasmacb);
            PuLogger.DebugLog(string.Format("PlasmaUsage Context enabled: {0}", BeSettings.Instance.PlasmaUsage));
            _change = true;
        }

        private void LowhealthtValueChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.LowHealthvalue = (int) _lowhealtht.Value;
            PuLogger.DebugLog(string.Format("LowHealthvalue Context enabled: {0}", BeSettings.Instance.LowHealthvalue));
            _change = true;
        }

        private void HealpottValueChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.HealPotValue = (int) _healpott.Value;
            PuLogger.DebugLog(string.Format("HealPotValue Context enabled: {0}", BeSettings.Instance.HealPotValue));
            _change = true;
        }

        private void ManapottValueChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.ManaPotValue = (int) _manapott.Value;
            PuLogger.DebugLog(string.Format("ManaPotValue Context enabled: {0}", BeSettings.Instance.ManaPotValue));
            _change = true;
        }

        private void AddcounttValueChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.AddcountValue = (int) _addcountt.Value;
            PuLogger.DebugLog(string.Format("AddcountValue Context enabled: {0}", BeSettings.Instance.AddcountValue));
            _change = true;
        }

        private void Button1Click(object sender, EventArgs e)
        {
            if (!_change) return;
            BeSettings.Instance.Spirit = checkBox1.Checked;
            BeSettings.Instance.HealPotValue = (int)_healpott.Value;
            BeSettings.Instance.ManaPotValue = (int)_manapott.Value;
            BeSettings.Instance.AddcountValue = (int)_addcountt.Value;
            BeSettings.Instance.LowHealthvalue = (int)_lowhealtht.Value;
            BeSettings.Instance.Trinket1Usage = (PuEnumeration.TrinketUsage)GetComboBoxEnum(_trinket1cbo);
            BeSettings.Instance.Trinket2Usage = (PuEnumeration.TrinketUsage)GetComboBoxEnum(_trinket2cbo);
            BeSettings.Instance.SsUsage = (PuEnumeration.SynapseSpringsUsage)GetComboBoxEnum(_synapsecb);
            BeSettings.Instance.PlasmaUsage = (PuEnumeration.PlasmaShieldUsage)GetComboBoxEnum(_plasmacb);
            BeSettings.Instance.PotionUsage = (PuEnumeration.PotionUsage)GetComboBoxEnum(_potscbo);
            BeSettings.Instance.ElixierUsage = (PuEnumeration.ElixierUsage)GetComboBoxEnum(_elixiercbo);
            BeSettings.Instance.FlaskUsage = (PuEnumeration.FlaskUsage)GetComboBoxEnum(_flaskcbo);
            BeSettings.Instance.Save();
            PuLogger.InfoLog("Settings saved.");
        }

        private void LinkLabel1LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            MessageBox.Show(
                "Credits to get this thing work with comboboxes goes to bobby53!\r\nAlso shout outs to the singular devs!\r\nThanks you all!",
                "Credits");
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            BeSettings.Instance.Spirit = checkBox1.Checked;
            PuLogger.DebugLog(string.Format("Spirit Context enabled: {0}", BeSettings.Instance.Spirit));
            _change = true;
        }
    }
}